=== debian/changelog ===
rustc (1.5.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
    - We believe that we should let rust transit to testing
      (Closes: #786836)
  * Move away from hash to the same rust naming schema

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 10 Dec 2015 17:23:32 +0100

rustc (1.4.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
    198068b3 => 1bf6e69c
  * Update the download url in debian/watch

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 30 Oct 2015 09:36:02 +0100

rustc (1.3.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
    62abc69f => 198068b3
  * jquery updated from 2.1.0 to 2.1.4

  [ Ximin Luo ]
  * Use LLVM 3.7 as upstream does, now that it's released. (Closes: #797626)
  * Fix debian/copyright syntax mistakes.
  * Don't Replace/Break previous versions of libstd-rust-*
  * Check that the libstd-rust-* name in d/control matches upstream.
  * Several other minor build tweaks.

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 19 Sep 2015 14:39:35 +0200

rustc (1.2.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
    libstd-rust-7d23ff90 => libstd-rust-62abc69f
  * Add llvm-3.6-tools to the build dep as it is
    now needed for tests
  * Fix the Vcs-Browser value

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 08 Aug 2015 23:13:44 +0200

rustc (1.1.0+dfsg1-3) unstable; urgency=medium

  * rust-{gdb,lldb} now Replaces pre-split rustc package.
    Closes: #793433.
  * Several minor lintian cleanups.

 -- Angus Lees <gus@debian.org>  Fri, 24 Jul 2015 17:47:48 +1000

rustc (1.1.0+dfsg1-2) unstable; urgency=medium

  [ Angus Lees ]
  * Replace remote Rust logo with local file in HTML docs.
  * Symlink rust-{gdb,lldb}.1 to {gdb,lldb}.1 manpages.
    Note that gdb.1 requires the gdb-doc package, and that lldb.1 doesn't
    exist yet (see #792908).
  * Restore "Architecture: amd64 i386" filter, mistakenly removed in
    previous version.  Unfortunately the toolchain bootstrap isn't ready
    to support all Debian archs yet.  Closes: #793147.

 -- Angus Lees <gus@debian.org>  Wed, 22 Jul 2015 09:51:08 +1000

rustc (1.1.0+dfsg1-1) unstable; urgency=low

  [ Angus Lees ]
  * Set SONAME when building dylibs
  * Split out libstd-rust, libstd-rust-dev, rust-gdb, rust-lldb from rustc
    - libs are now installed into multiarch-friendly locations
    - rpath is no longer required to use dylibs (but talk to Debian Rust
      maintainers before building a package that depends on the dylibs)
  * Install /usr/share/rustc/architecture.mk, which declares Rust arch
    triples for Debian archs and is intended to help future Rust packaging
    efforts.  Warning: it may not be complete/accurate yet.
  * New upstream release (1.1)

 -- Angus Lees <gus@debian.org>  Thu, 16 Jul 2015 14:23:47 +1000

rustc (1.0.0+dfsg1-1) unstable; urgency=medium

  [ Angus Lees ]
  * New upstream release (1.0!)

  [ Sylvestre Ledru ]
  * Fix the watch file
  * Update of the repack to remove llvm sources

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 16 May 2015 08:24:32 +1000

rustc (1.0.0~beta.4-1~exp1) experimental; urgency=low

  [ Angus Lees ]
  * New upstream release (beta 3)
    - Drop manpage patch - now included upstream
  * Replace duplicated compile-time dylibs with symlinks to run-time libs
    (reduces installed size by ~68MB)

  [ Sylvestre Ledru ]
  * New upstream release (beta 4)
  * Replace two more occurrences of jquery by the package
  * Repack upstream to remove an LLVM file with a non-DFSG license

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 06 May 2015 11:14:30 +0200

rustc (1.0.0~alpha.2-1~exp1) experimental; urgency=low

  [ Angus Lees ]
  * Patch upstream manpages to address minor troff issues
  * Make 'debian/rules clean' also clean LLVM source
  * Rename primary 'rust' binary package to 'rustc'
  * Fix potential FTBFS: rust-doc requires texlive-fonts-recommended (for
    pzdr.tfm)
  * Build against system LLVM

  [ Sylvestre Ledru ]
  * New testing release
  * Renaming of the source package
  * Set a minimal version for dpkg-dev and debhelper (for profiles)
  * For now, disable build profiles as they are not supported in Debian
  * Introduce some changes by Angus Lees
    - Introduction of build stages
    - Disable the parallel execution of tests
    - Improving of the parallel syntax
    - Use override_dh_auto_build-arch
    - Use override_dh_auto_build-indep
    - Better declarations of the doc
    - Update of the description
    - Watch file updated (with key check)

  [ Luca Bruno ]
  * rules: respect 'nocheck' DEB_BUILD_OPTIONS

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 07 Mar 2015 09:25:47 +0100

rust (1.0.0~alpha-0~exp1) experimental; urgency=low

  * Initial package (Closes: #689207)
    Work done by Luca Bruno, Jordan Justen and Sylvestre Ledru

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 23 Jan 2015 15:47:37 +0100
